/* configuration */
Call Rxfuncadd 'SysLoadFuncs','Rexxutil','SysLoadFuncs'
Call SysLoadFuncs
Trace 'n'
Arg test_appl .
java_exe = 'ERROR:'
/* locate java 1.1.8 */
java_exe = Jvm_dir(Java118(),java_exe)
/* check the current path */
If java_exe = 'ERROR:' Then java_exe = Jvm_dir(SysSearchPath('path','java.exe'),java_exe)
If java_exe = 'ERROR:' Then Do
   /* check for InnoTek Java */
   j. = ''
   j.1 = 'OS2 Kit for Java'
   j.2 = 'OS2 Kit for Java SDK'
   j.0 = 2
   Do x = 1 To j.0 While java_exe = 'ERROR:'
      t_ver = Strip(SysIni('user',j.x,'CurrentVersion'),'t','00'x)
      If t_ver <> 'ERROR:' Then java_exe = Jvm_dir(Strip(SysIni('user',j.x,t_ver),'t','00'x),java_exe)
   End
End
/* check for Golden Code */
If java_exe = 'ERROR:' Then java_exe = Jvm_dir(Value('gcd_java_home',,'os2environment'),java_exe)
java_parms = 'ERROR:'
If java_exe <> 'ERROR:' Then Do
   java_dir = Strip(Filespec('d',java_exe)||Filespec('p',java_exe),'t','\')
   java_base = Left(java_dir,Lastpos('\',java_dir) - 1)
   class_path = Value('classpath',,'os2environment')
   If Right(class_path,1) <> ';' Then class_path = class_path||';'
   If Stream(java_base||'\lib\SecMA.jar','c','query exists') <> '' Then Do
      If Pos(Translate(java_base||'\lib\SecMA.jar'),Translate(class_path)) = 0 Then class_path = class_path||java_base||'\lib\SecMA.jar;'
   End
   If Stream(java_base||'\Swing\swingall.jar','c','query exists') <> '' Then Do
      If Pos(Translate(java_base||'\Swing\swingall.jar'),Translate(class_path)) = 0 Then class_path = class_path||java_base||'\Swing\swingall.jar;'
   End
   If Stream(java_base||'\lib\classes.zip','c','query exists') <> '' Then Do
      If Pos(Translate(java_base||'\lib\classes.zip'),Translate(class_path)) = 0 Then class_path = class_path||java_base||'\lib\classes.zip;'
   End
   Select
      When test_appl = 'TCP' Then Do
         test_exe = SysSearchPath('path','tcpstart.cmd')
         If test_exe <> '' Then Do
            tcp_dir = Strip(Filespec('d',test_exe)||Filespec('p',test_exe),'t','\')
            tcp_java_dir = Left(tcp_dir,Lastpos('\',tcp_dir))||'java'
            If Stream(tcp_java_dir||'\tcpauth.jar','c','query exists') <> '' Then Do
               tcp_lang = Value('tcplang',,'os2environment')
               If tcp_lang = '' Then tcp_lang = Value('lang',,'os2environment')
               If tcp_lang <> '' Then Do
                  tcp_java_lang_dir = tcp_java_dir||'\'||tcp_lang
                  If Stream(tcp_java_lang_dir||'\tcpares.jar','c','query exists') <> '' Then Do
                     tcp_etc = Value('etc',,'os2environment')
                     If tcp_etc <> '' Then java_parms = java_exe java_dir class_path tcp_dir tcp_java_dir tcp_lang tcp_java_lang_dir tcp_etc
                     Else Say 'Unable to locate ETC'
                  End
                  Else Say 'Unable to locate TCP/IP Java' tcp_lang 'directory'
               End
               Else Say 'Unable to determine language'
            End
            Else Say 'Unable to locate TCP/IP Java directory'
         End
         Else Say 'Unable to locate TCP/IP directory'
      End
      When test_appl = 'LVM' Then Do
         test_exe = SysSearchPath('path','lvm.exe')
         If test_exe <> '' Then Do
            lvm_dir = Strip(Filespec('d',test_exe)||Filespec('p',test_exe),'t','\')
            lvm_java_dir = lvm_dir||'\javaapps'
            If Stream(lvm_java_dir||'\lvmgui.zip','c','query exists') <> '' Then java_parms = java_exe java_dir class_path lvm_dir lvm_java_dir
            Else Say 'Unable to locate LVMGUI Java directory'
         End
         Else Say 'Unable to locate LVMGUI directory'
      End
      When test_appl = 'GSK' Then Do
         test_exe = SysSearchPath('path','gskver.exe')
         If test_exe == '' Then Do
            test_exe = Stream(Strip(Value('ikeyman_home',,'os2environment'),'t','\')||'\bin\gskver.exe','c','query exists')
         End
         If test_exe <> '' Then Do
            gsk_dir = Strip(Filespec('d',test_exe)||Filespec('p',test_exe),'t','\')
            gsk_java_dir = Left(gsk_dir, Lastpos('\',gsk_dir))||'classes'
            If Stream(gsk_java_dir||'\cssgkey.jar','c','query exists') <> '' Then java_parms = java_exe java_dir class_path gsk_dir gsk_java_dir
            Else Say 'Unable to locate IBMGSK Java directory'
         End
         Else Say 'Unable to locate IBMGSK directory'
      End
      When test_appl = 'GSK40' Then Do
         test_exe = SysSearchPath('path','gsk4ver.exe')
         If test_exe == '' Then Do
            test_exe = Stream(Strip(Value('ikeyman40_home',,'os2environment'),'t','\')||'\bin\gsk4ver.exe','c','query exists')
         End
         If test_exe <> '' Then Do
            gsk_dir = Strip(Filespec('d',test_exe)||Filespec('p',test_exe),'t','\')
            gsk_java_dir = Left(gsk_dir, Lastpos('\',gsk_dir))||'classes'
            If Stream(gsk_java_dir||'\gsk4cls.jar','c','query exists') <> '' Then java_parms = java_exe java_dir class_path gsk_dir gsk_java_dir
            Else Say 'Unable to locate IBMGSK40 Java directory'
         End
         Else Say 'Unable to locate IBMGSK40 directory'
      End
      When test_appl = 'GSK50' Then Do
         test_exe = SysSearchPath('path','gsk5ver.exe')
         If test_exe == '' Then Do
            test_exe = Stream(Strip(Value('ikeyman50_home',,'os2environment'),'t','\')||'\bin\gsk5ver.exe','c','query exists')
         End
         If test_exe <> '' Then Do
            gsk_dir = Strip(Filespec('d',test_exe)||Filespec('p',test_exe),'t','\')
            gsk_java_dir = Left(gsk_dir, Lastpos('\',gsk_dir))||'classes'
            If Stream(gsk_java_dir||'\gsk5cls.jar','c','query exists') <> '' Then java_parms = java_exe java_dir class_path gsk_dir gsk_java_dir
            Else Say 'Unable to locate IBMGSK50 Java directory'
         End
         Else Say 'Unable to locate IBMGSK50 directory'
      End
      Otherwise java_parms = 'ERROR:'
   End
End
Else Say 'Unable to locate java.exe'
If java_exe = 'ERROR:' Then Do
   Say 'Press any key to continue'
   Pull .
End
Return java_parms

Jvm_dir: Procedure
Parse Arg t_dir,t_exe,.
If Pos('.',t_dir) <> 0 Then t_dir = Left(t_dir,Lastpos('\',t_dir))
t_dir = Strip(t_dir,'t','\')
If t_dir <> '' Then Do
   If Stream(t_dir||'\java.exe','c','query exists') <> '' Then t_exe = t_dir||'\JAVA.EXE'
   Else Do
      If SysFileTree(t_dir||'\java.exe','t_file.','fso') = 0 Then Do
         If t_file.0 <> 0 Then t_exe = t_file.1
      End
   End
End
Return Translate(t_exe)

Java118: Procedure
/* check for JAVA11_HOME */
Arg t_file,.
t_dir = Value('JAVA11_HOME',,'os2environment')
If t_dir <> '' Then Do
   If SysFileTree(t_dir||'\SYSLEVEL.JAV','file.','fso') = 0 Then Do x = 1 To file.0
      If Check_version(file.x,'XR04009',) Then Return Strip(Filespec('d',file.x)||Filespec('p',file.x),'t','\')
   End
End
/* scan \os2\install\syspath.dat on all local drives */
syspath = '\OS2\INSTALL\SYSPATH.DAT'
drives = SysDriveMap(,'LOCAL')
Do x = 1 To Words(drives)
   If SysFileSearch('\JAVA11\BIN\SYSLEVEL.JAV',Word(drives,x)||syspath,'file.') = 0 Then Do y = 1 To file.0
      If Check_version(file.y,'XR04009',) Then Return Strip(Filespec('d',file.y)||Filespec('p',file.y),'t','\')
   End
End
Return t_file

Check_version: Procedure
Arg file,version,test,.
If Stream(file,'c','open read') = 'READY:' Then Do
   test = Charin(file,45,7)
   Call Stream file,'c','close'
End
Return (version = test)
