/* configuration */
Call Rxfuncadd 'SysLoadFuncs','Rexxutil','SysLoadFuncs'
Call SysLoadFuncs
Trace 'n'
Arg test_appl .
boot_drive = SysBootDrive()
If test_appl = 'BACKUP' Then Do
   Call Jvm_backup
   Return 0
End
If test_appl = 'SET_OBJECT' Then Do
   Arg test_appl obj_id parms .
   Return SysSetObjectData('<'||obj_id||'>',parms)
End
If test_appl = 'ERASE_FILE' Then Do
   Arg test_appl parms .
   Return SysFileDelete(parms)
End
syslevel_os2 = Stream(boot_drive||'\os2\install\syslevel.os2','c','query exists')
If syslevel_os2 = '' Then Do
   Say 'Unable to locate' boot_drive||'\os2\install\syslevel.os2'
   Return '"JVM Configurator"'
End
Call Stream syslevel_os2,'c','open read'
sys_lang = Translate(Charin(syslevel_os2,55,1))
Call Stream syslevel_os2,'c','close'
Select
   When sys_lang = 'G' Then
   Select
      When test_appl = 'ADMIN_PW' Then jvm_title = '"TCP/IP Administrator Password"'
      When test_appl = 'BINLSCPC' Then jvm_title = '"BINL-Server-Konfiguration"'
      When test_appl = 'BINLSCPS' Then jvm_title = '"BINL Server Administrator"'
      When test_appl = 'DADMGUI' Then jvm_title = '"DHCP-Server-Management"'
      When test_appl = 'DDNSAPC' Then jvm_title = '"DDNS-Server-Administrator"'
      When test_appl = 'DDNSAPS' Then jvm_title = '"DDNS Server Administrator"'
      When test_appl = 'DHCPSCPC' Then jvm_title = '"DHCP-Server-Konfiguration"'
      When test_appl = 'DHCPSCPS' Then jvm_title = '"DHCP-Server-Konfiguration (Dmonproze)"'
      When test_appl = 'IKMGUI' Then jvm_title = '"IBM Key-Management"'
      When test_appl = 'LVMGUI' Then jvm_title = '"LVM-Konfiguration"'
      When test_appl = 'TCPCFG2' Then jvm_title = '"TCP/IP-Konfiguration (Lokal)"'
      When test_appl = 'TCPCFG2D' Then jvm_title = '"Fernkonfiguration zulassen"'
      When test_appl = 'TCPCFG2R' Then jvm_title = '"Fernes System konfigurieren"'
      Otherwise jvm_title = '"JVM-Konfiguration"'
   End
   When sys_lang = 'H' Then Select
      When test_appl = 'ADMIN_PW' Then jvm_title = '"Beheerderswachtwoord voor TCP/IP Opgeven"'
      When test_appl = 'BINLSCPC' Then jvm_title = '"BINL Server Configuratie"'
      When test_appl = 'BINLSCPS' Then jvm_title = '"BINL Server Administrator"'
      When test_appl = 'DADMGUI' Then jvm_title = '"DHCP Server Beheer"'
      When test_appl = 'DDNSAPC' Then jvm_title = '"DDNS Server Configuratie"'
      When test_appl = 'DDNSAPS' Then jvm_title = '"Configuratie-daemon DDNS Server"'
      When test_appl = 'DHCPSCPC' Then jvm_title = '"DHCP Server Configuratie"'
      When test_appl = 'DHCPSCPS' Then jvm_title = '"Configuratie-daemon DHCP Server"'
      When test_appl = 'IKMGUI' Then jvm_title = '"IBM Key Beheer"'
      When test_appl = 'LVMGUI' Then jvm_title = '"LVM Configuratie"'
      When test_appl = 'TCPCFG2' Then jvm_title = '"TCP/IP Configuratie (Lokaal)"'
      When test_appl = 'TCPCFG2D' Then jvm_title = '"Configuratie op Afstand Toestaan"'
      When test_appl = 'TCPCFG2R' Then jvm_title = '"Configuratie Systeem op Afstand"'
      Otherwise jvm_title = '"JVM Configuratie"'
   End
   Otherwise Select
      When test_appl = 'ADMIN_PW' Then jvm_title = '"TCP/IP Administrator Password"'
      When test_appl = 'BINLSCPC' Then jvm_title = '"BINL Server Configurator"'
      When test_appl = 'BINLSCPS' Then jvm_title = '"BINL Server Administrator"'
      When test_appl = 'DADMGUI' Then jvm_title = '"DHCP Server Management"'
      When test_appl = 'DDNSAPC' Then jvm_title = '"DDNS Server Configurator"'
      When test_appl = 'DDNSAPS' Then jvm_title = '"DDNS Server Administrator"'
      When test_appl = 'DHCPSCPC' Then jvm_title = '"DHCP Server Configurator"'
      When test_appl = 'DHCPSCPS' Then jvm_title = '"DHCP Server Administrator"'
      When test_appl = 'IKMGUI' Then jvm_title = '"IBM Key Management"'
      When test_appl = 'LVMGUI' Then jvm_title = '"LVM Configurator"'
      When test_appl = 'TCPCFG2' Then jvm_title = '"TCP/IP Configurator (local)"'
      When test_appl = 'TCPCFG2D' Then jvm_title = '"TCP/IP Configuration Server"'
      When test_appl = 'TCPCFG2R' Then jvm_title = '"TCP/IP Configurator (client)"'
      Otherwise jvm_title = '"JVM Configurator"'
   End
End

Return jvm_title

Jvm_backup:
zip_file = boot_drive||'\VAR\LOG\jvm_backup.zip'
netwdrv = Value('DPF_NETDRIVE',,'OS2ENVIRONMENT')
If netwdrv <> '' Then tcp_bin = netwdrv||'\tcpip\bin\'
Else tcp_bin = Rx_searchpath(boot_drive,'path','tcpstart.cmd')
If tcp_bin <> '' Then tcp_bin = Strip(Filespec('d',tcp_bin)||Filespec('p',tcp_bin),'t','\')
Else tcp_bin = ''

gsk_bin = Value('ikeyman_home',,'os2environment')
If gsk_bin <> '' Then gsk_bin = gsk_bin||'\bin'
Else Do
   Parse Upper Value Rx_findlines(' ikeyman_home',boot_drive||'\CONFIG.SYS',,'set ikeyman_home=') With _no _line '|' .
   If _no <> 0 Then Do
      Parse Var _line . '=' _search
      gsk_bin = Strip(Strip(_search),'t',';')||'\bin'
   End
   Else gsk_bin = ''
End

gsk40_bin = Value('ikeyman40_home',,'os2environment')
If gsk40_bin <> '' Then gsk40_bin = gsk40_bin||'\bin'
Else Do
   Parse Upper Value Rx_findlines(' ikeyman40_home',boot_drive||'\CONFIG.SYS',,'set ikeyman40_home=') With _no _line '|' .
   If _no <> 0 Then Do
      Parse Var _line . '=' _search
      gsk40_bin = Strip(Strip(_search),'t',';')||'\bin'
   End
   Else gsk40_bin = ''
End

gsk50_bin = Value('ikeyman50_home',,'os2environment')
If gsk50_bin <> '' Then gsk50_bin = gsk50_bin||'\bin'
Else Do
   Parse Upper Value Rx_findlines(' ikeyman50_home',boot_drive||'\CONFIG.SYS',,'set ikeyman50_home=') With _no _line '|' .
   If _no <> 0 Then Do
      Parse Var _line . '=' _search
      gsk50_bin = Strip(Strip(_search),'t',';')||'\bin'
   End
   Else gsk50_bin = ''
End

If Stream(boot_drive||'\os2\lvmgui.cmd','c','query exists') <> '' Then Address cmd 'zip.exe -oDX9mq' zip_file boot_drive||'\os2\lvmgui.cmd > nul'
If gsk_bin <> '' Then Address cmd 'zip.exe -oDX9mq' zip_file gsk_bin||'\*.cmd > nul'
If gsk40_bin <> '' Then Address cmd 'zip.exe -oDX9mq' zip_file gsk40_bin||'\*.cmd > nul'
If gsk40_bin <> '' Then Address cmd 'zip.exe -oDX9mq' zip_file gsk40_bin||'\*.cmd > nul'
If gsk50_bin <> '' Then Address cmd 'zip.exe -oDX9mq' zip_file gsk50_bin||'\*.cmd > nul'
If tcp_bin <> '' Then Do
   Address cmd 'zip.exe -oDX9mq' zip_file tcp_bin||'\admin_pw.cmd > nul'
   Address cmd 'zip.exe -oDX9mq' zip_file tcp_bin||'\binlsc*.cmd > nul'
   Address cmd 'zip.exe -oDX9mq' zip_file tcp_bin||'\dadmgui.cmd > nul'
   Address cmd 'zip.exe -oDX9mq' zip_file tcp_bin||'\ddnsa*.cmd > nul'
   Address cmd 'zip.exe -oDX9mq' zip_file tcp_bin||'\dhcpsc*.cmd > nul'
   Address cmd 'zip.exe -oDX9mq' zip_file tcp_bin||'\tcpcfg*.cmd > nul'
End
Return

/* search a path in config.sys */
Rx_searchpath: Procedure
Arg _drv,_path,_mod,.
_drv = Left(_drv,1)||':'
If _path = '' Then Return ''
Parse Value '' With _search .
_key = _path
_ver = _path||'='
If _path <> 'LIBPATH' Then Do
   _key = '20'x||_key
   _ver = 'SET' _ver
End
Parse Upper Value Rx_findlines(_key,_drv||'\CONFIG.SYS',,_ver) With _no _line '|' .
If _no <> 0 Then Parse Var _line . '=' _search
_search = Strip(Strip(_search),'t',';')||';'
Do While Pos('.;',_search) <> 0
   _pos = Pos('.;',_search)
   _search = Delstr(_search,_pos,2)
End
Do While Pos('.\',_search) <> 0
   _pos = Pos('.\',_search)
   Parse Value '.' _search With . _p1 =(_pos) . ';' _p2
   _search = _p1||_p2
End
If _search = '' Then Return ''
If _mod = '' Then Return _search
Return Rx_file_dpath(_mod,_search)

/* find the first occurance of a file in a path */
Rx_file_dpath: Procedure
Arg _name,_list,.
Parse Value '' With _path _dirs _dir .
_name = Strip(_name)
If _name = '' Then Return _path
If Pos('\',_name) <> 0 Then Return _path
_dirs = Strip(_list,'t',';')||';'
Do While (_dirs <> '' & _path = '')
   Parse Var _dirs _dir ';' _dirs
   If _dir <> '' Then
   If Rx_file_exists(_dir||'\'||_name) Then
   _path = Translate(_dir||'\'||_name)
End
Return _path

Rx_file_exists: Procedure
Arg _file,.
If Pos(':\',_file) = 2 Then Call SysFileTree _file, 't.','fo'
Else Return 0
Return (t.0 <> 0)

/* find a phrase in a file and return the line number,
   line, and all remmed out lines containing the phrase */
Rx_findlines: Procedure
Parse Arg _phrase,_file,.
If _phrase = '' | \Rx_file_exists(_file) Then Return '0 |'
Arg ,,_flag,_begin,.
_first = (Pos('F',_flag) <> 0)
Parse Value 0 With found_no found_line rem_no .
Call Stream _file,'c','close'
If SysFileSearch(_phrase,_file,'_lines.','N') <> 0 Then Return '0 |'
Do i = 1 To _lines.0
   Parse Var _lines.i _no line
   line = Strip(line)
   line_test = Strip(Strip(Translate(Space(line)),,"'"),,'"')
   If Pos('=',_begin) <> 0 Then Do
      _delim = Pos('=',line_test)
      If _delim <> 0 Then Do
         line_test = Strip(Left(line_test,_delim - 1))||'='
         rem_test = Wordpos('REM',Subword(line_test,2))
         Do While rem_test <> 0
            line_test = Delword(line_test,rem_test,1)
            rem_test = Wordpos('REM',Subword(line_test,2))
         End
      End
   End
   If _begin <> '' Then
   If \Abbrev(line_test,_begin) & \Abbrev(line_test,'REM' _begin) Then Iterate i
   If Abbrev(line_test,'REM') | Abbrev(line_test,'/*') | Abbrev(line_test,';') Then Do
      rem_no = rem_no _no
      Iterate i
   End
   Else Do
      found_no = _no
      found_line = line
      If _first Then Leave i
   End
End
Return found_no found_line '|' Space(rem_no)
